# MonitorClient

> see https://aka.ms/autorest

This is the AutoRest configuration file for MonitorClient.



---
## Getting Started
To build the SDK for MonitorClient, simply [Install AutoRest](https://aka.ms/autorest/install) and in this folder, run:

> `autorest`

To see additional help and options, run:

> `autorest --help`
---

## Configuration



### Basic Information
These are the global settings for the MonitorClient API.

``` yaml
title: MonitorClient
description: Monitor Management Client
openapi-type: arm

tag: package-2018-09

```
### Tag: package-2018-09

These settings apply only when `--tag=package-2018-09` is specified on the command line.

``` yaml $(tag) == 'package-2018-09'
input-file:
- microsoft.insights/stable/2015-04-01/autoscale_API.json
- microsoft.insights/stable/2015-04-01/operations_API.json
- microsoft.insights/stable/2016-03-01/alertRulesIncidents_API.json
- microsoft.insights/stable/2016-03-01/alertRules_API.json
- microsoft.insights/stable/2016-03-01/logProfiles_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettings_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettingsCategories_API.json
- microsoft.insights/stable/2018-09-01/actionGroups_API.json
- microsoft.insights/stable/2017-04-01/activityLogAlerts_API.json
- microsoft.insights/stable/2015-04-01/activityLogs_API.json
- microsoft.insights/stable/2015-04-01/eventCategories_API.json
- microsoft.insights/stable/2015-04-01/tenantActivityLogs_API.json
- microsoft.insights/stable/2018-01-01/metricDefinitions_API.json
- microsoft.insights/stable/2018-01-01/metrics_API.json
- microsoft.insights/preview/2017-11-01-preview/baseline_API.json
- microsoft.insights/preview/2017-11-01-preview/calculateBaseline_API.json
- microsoft.insights/stable/2018-03-01/metricAlert_API.json
- microsoft.insights/stable/2018-04-16/scheduledQueryRule_API.json
- microsoft.insights/preview/2017-12-01-preview/metricNamespaces_API.json
```

### Tag: package-2018-03

These settings apply only when `--tag=package-2018-03` is specified on the command line.

``` yaml $(tag) == 'package-2018-03'
input-file:
- microsoft.insights/stable/2015-04-01/autoscale_API.json
- microsoft.insights/stable/2015-04-01/operations_API.json
- microsoft.insights/stable/2016-03-01/alertRulesIncidents_API.json
- microsoft.insights/stable/2016-03-01/alertRules_API.json
- microsoft.insights/stable/2016-03-01/logProfiles_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettings_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettingsCategories_API.json
- microsoft.insights/stable/2018-09-01/actionGroups_API.json
- microsoft.insights/stable/2017-04-01/activityLogAlerts_API.json
- microsoft.insights/stable/2015-04-01/activityLogs_API.json
- microsoft.insights/stable/2015-04-01/eventCategories_API.json
- microsoft.insights/stable/2015-04-01/tenantActivityLogs_API.json
- microsoft.insights/stable/2018-01-01/metricDefinitions_API.json
- microsoft.insights/stable/2018-01-01/metrics_API.json
- microsoft.insights/preview/2017-11-01-preview/baseline_API.json
- microsoft.insights/preview/2017-11-01-preview/calculateBaseline_API.json
- microsoft.insights/stable/2018-03-01/metricAlert_API.json
- microsoft.insights/stable/2018-04-16/scheduledQueryRule_API.json
```


### Tag: package-2018-02-preview

These settings apply only when `--tag=package-2018-02-preview` is specified on the command line.

``` yaml $(tag) == 'package-2018-02-preview'
input-file:
- microsoft.insights/stable/2015-04-01/autoscale_API.json
- microsoft.insights/stable/2015-04-01/operations_API.json
- microsoft.insights/stable/2016-03-01/alertRulesIncidents_API.json
- microsoft.insights/stable/2016-03-01/alertRules_API.json
- microsoft.insights/stable/2016-03-01/logProfiles_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettings_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettingsCategories_API.json
- microsoft.insights/stable/2018-09-01/actionGroups_API.json
- microsoft.insights/stable/2017-04-01/activityLogAlerts_API.json
- microsoft.insights/stable/2015-04-01/activityLogs_API.json
- microsoft.insights/stable/2015-04-01/eventCategories_API.json
- microsoft.insights/stable/2015-04-01/tenantActivityLogs_API.json
- microsoft.insights/stable/2018-01-01/metricDefinitions_API.json
- microsoft.insights/stable/2018-01-01/metrics_API.json
- microsoft.insights/preview/2017-11-01-preview/baseline_API.json
- microsoft.insights/preview/2017-11-01-preview/calculateBaseline_API.json
```


### Tag: package-2017-12

These settings apply only when `--tag=package-2017-12` is specified on the command line.

``` yaml $(tag) == 'package-2017-12'
input-file:
- microsoft.insights/stable/2015-04-01/autoscale_API.json
- microsoft.insights/stable/2015-04-01/operations_API.json
- microsoft.insights/stable/2016-03-01/alertRulesIncidents_API.json
- microsoft.insights/stable/2016-03-01/alertRules_API.json
- microsoft.insights/stable/2016-03-01/logProfiles_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettings_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettingsCategories_API.json
- microsoft.insights/stable/2018-09-01/actionGroups_API.json
- microsoft.insights/stable/2017-04-01/activityLogAlerts_API.json
- microsoft.insights/stable/2015-04-01/activityLogs_API.json
- microsoft.insights/stable/2015-04-01/eventCategories_API.json
- microsoft.insights/stable/2015-04-01/tenantActivityLogs_API.json
- microsoft.insights/preview/2017-05-01-preview/metricDefinitions_API.json
- microsoft.insights/preview/2017-05-01-preview/metrics_API.json
- microsoft.insights/preview/2017-11-01-preview/baseline_API.json
- microsoft.insights/preview/2017-11-01-preview/calculateBaseline_API.json
```

### Tag: package-2017-09

These settings apply only when `--tag=package-2017-09` is specified on the command line.

``` yaml $(tag) == 'package-2017-09'
input-file:
- microsoft.insights/stable/2015-04-01/autoscale_API.json
- microsoft.insights/stable/2015-04-01/operations_API.json
- microsoft.insights/stable/2016-03-01/alertRulesIncidents_API.json
- microsoft.insights/stable/2016-03-01/alertRules_API.json
- microsoft.insights/stable/2016-03-01/logProfiles_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettings_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettingsCategories_API.json
- microsoft.insights/stable/2018-09-01/actionGroups_API.json
- microsoft.insights/stable/2017-04-01/activityLogAlerts_API.json
- microsoft.insights/stable/2015-04-01/activityLogs_API.json
- microsoft.insights/stable/2015-04-01/eventCategories_API.json
- microsoft.insights/stable/2015-04-01/tenantActivityLogs_API.json
- microsoft.insights/preview/2017-05-01-preview/metricDefinitions_API.json
- microsoft.insights/preview/2017-05-01-preview/metrics_API.json
- microsoft.insights/preview/2017-11-01-preview/baseline_API.json
- microsoft.insights/preview/2017-11-01-preview/calculateBaseline_API.json
```

### Tag: package-2017-08

These settings apply only when `--tag=package-2017-08` is specified on the command line.

``` yaml $(tag) == 'package-2017-08'
input-file:
- microsoft.insights/stable/2015-04-01/autoscale_API.json
- microsoft.insights/stable/2015-04-01/operations_API.json
- microsoft.insights/stable/2016-03-01/alertRulesIncidents_API.json
- microsoft.insights/stable/2016-03-01/alertRules_API.json
- microsoft.insights/stable/2016-03-01/logProfiles_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettings_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettingsCategories_API.json
- microsoft.insights/stable/2018-09-01/actionGroups_API.json
- microsoft.insights/stable/2017-04-01/activityLogAlerts_API.json
```

### Tag: package-2018-01-01-only

These settings apply only when `--tag=package-2018-01-01-only` is specified on the command line.

``` yaml $(tag) == 'package-2018-01-01-only'
input-file:
- microsoft.insights/stable/2018-01-01/metricDefinitions_API.json
- microsoft.insights/stable/2018-01-01/metrics_API.json
```

### Tag: package-2018-03-01-only

These settings apply only when `--tag=package-2018-03-01-only` is specified on the command line.

``` yaml $(tag) == 'package-2018-03-01-only'
input-file:
- microsoft.insights/stable/2018-03-01/metricAlert_API.json
- microsoft.insights/stable/2018-03-01/actionGroups_API.json
```

### Tag: package-2018-04-16-only

These settings apply only when `--tag=package-2018-04-16-only` is specified on the command line.

``` yaml $(tag) == 'package-2018-04-16-only'
input-file:
- microsoft.insights/stable/2018-04-16/scheduledQueryRule_API.json
```

### Tag: package-2015-04-01-only

These settings apply only when `--tag=package-2015-04-01-only` is specified on the command line.

``` yaml $(tag) == 'package-2015-04-01-only'
input-file:
- microsoft.insights/stable/2015-04-01/activityLogs_API.json
- microsoft.insights/stable/2015-04-01/autoscale_API.json
- microsoft.insights/stable/2015-04-01/eventCategories_API.json
- microsoft.insights/stable/2015-04-01/operations_API.json
- microsoft.insights/stable/2015-04-01/tenantActivityLogs_API.json
```

### Tag: package-2016-03-01-only

These settings apply only when `--tag=package-2016-03-01-only` is specified on the command line.

``` yaml $(tag) == 'package-2016-03-01-only'
input-file:
- microsoft.insights/stable/2016-03-01/alertRules_API.json
- microsoft.insights/stable/2016-03-01/alertRulesIncidents_API.json
- microsoft.insights/stable/2016-03-01/logProfiles_API.json
- microsoft.insights/stable/2016-03-01/metricDefinitions_API.json
```

### Tag: package-2016-09-01-only

These settings apply only when `--tag=package-2016-09-01-only` is specified on the command line.

``` yaml $(tag) == 'package-2016-09-01-only'
input-file:
- microsoft.insights/stable/2016-09-01/metrics_API.json
- microsoft.insights/stable/2016-09-01/serviceDiagnosticsSettings_API.json
```

### Tag: package-2017-04-01-only

These settings apply only when `--tag=package-2017-04-01-only` is specified on the command line.

``` yaml $(tag) == 'package-2017-04-01-only'
input-file:
- microsoft.insights/stable/2017-04-01/actionGroups_API.json
- microsoft.insights/stable/2017-04-01/activityLogAlerts_API.json
```

### Tag: package-2017-05-01-preview-only

These settings apply only when `--tag=package-2017-05-01-preview-only` is specified on the command line.

``` yaml $(tag) == 'package-2017-05-01-preview-only'
input-file:
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettings_API.json
- microsoft.insights/preview/2017-05-01-preview/diagnosticsSettingsCategories_API.json
- microsoft.insights/preview/2017-05-01-preview/metricDefinitions_API.json
- microsoft.insights/preview/2017-05-01-preview/metrics_API.json
```

### Tag: package-2017-11-01-preview-only

These settings apply only when `--tag=package-2017-11-01-preview-only` is specified on the command line.

``` yaml $(tag) == 'package-2017-11-01-preview-only'
input-file:
- microsoft.insights/preview/2017-11-01-preview/baseline_API.json
- microsoft.insights/preview/2017-11-01-preview/calculateBaseline_API.json
```

---
# Code Generation


## Swagger to SDK

This section describes what SDK should be generated by the automatic system.
This is not used by Autorest itself.

``` yaml $(swagger-to-sdk)
swagger-to-sdk:
  - repo: azure-sdk-for-python
  - repo: azure-sdk-for-java
  - repo: azure-sdk-for-go
  - repo: azure-sdk-for-js
  - repo: azure-sdk-for-node
  - repo: azure-sdk-for-ruby
    after_scripts:
      - bundle install && rake arm:regen_all_profiles['azure_mgmt_monitor']
```


## C#

These settings apply only when `--csharp` is specified on the command line.
Please also specify `--csharp-sdks-folder=<path to "SDKs" directory of your azure-sdk-for-net clone>`.

``` yaml $(csharp)
csharp:
  azure-arm: true
  payload-flattening-threshold: 1
  license-header: MICROSOFT_MIT_NO_VERSION
  namespace: Microsoft.Azure.Management.Monitor
  output-folder: $(csharp-sdks-folder)/Monitor/Management.Monitor/Generated
  clear-output-folder: true
```

## Python

See configuration in [readme.python.md](./readme.python.md)

## Go

See configuration in [readme.go.md](./readme.go.md)

## Java

These settings apply only when `--java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-libraries-for-java clone>`.

``` yaml $(java)
azure-arm: true
fluent: true
namespace: com.microsoft.azure.management.monitor
license-header: MICROSOFT_MIT_NO_CODEGEN
payload-flattening-threshold: 1
output-folder: $(azure-libraries-for-java-folder)/azure-mgmt-monitor
```

# Validation

## Suppression

``` yaml
directive:
  - suppress: R3016  # DefinitionsPropertiesNamesCamelCase (to suppress the error due to odata.type)
    reason: The feature (polymorphic types) is in the process of deprecation and fixing this will require changes in the backend.
```
